* Memo fields, text file limits and increasing EditBox size test results

#include <hmg.ch>

#define Msg( xValue, xTitle ) MsgBox( IF( HB_ISCHAR( xValue  ), xValue , HB_ValToExp( xValue ) ), ;
                                      IF( HB_ISNIL( xTitle ), '', ;
                                      IF( HB_ISCHAR( xTitle ), xTitle, HB_ValToExp( xTitle ) ) ) )
                                      
#define TTrim( n ) LTRIM( TRAN( n, "999,9999,999,999,999,999" ) )

PROCEDURE Main()

   FIELD GF_NAME, GF_DATA
   
   PRIVATE MemoFName := "MmoLmTst",;
           ReadFName := "",;
           SaveFName := ""
           
   PRIVATE aHFStruct := { { "GF_NAME", "C", 64, 0 },;     // Guest file name
                        { "GF_DATA", "M", 10, 0 } }    // Guest file data                  
   
   PRIVATE nReadLen := 0,;
           nReplLen := 0,;
           nSaveLen := 0
   
   SET CENT ON    
   SET DATE GERM
   SET TOOLTIPSTYLE BALLOON

	DEFINE WINDOW frmMLTest ;
		AT 0,0 ;
		WIDTH 640 ;
		HEIGHT 510 ;
		TITLE 'Test MEMO and EditBox limit ' ;
      ON INIT Initilize() ;
		MAIN 
      
      ON KEY ESCAPE OF frmMLTest ACTION ThisWindow.Release
      
		DEFINE MAIN MENU
			DEFINE POPUP '&File'
            ITEM 'Read ( File -> Editbox )'   NAME mitReadFile ACTION ReadFile()
            ITEM 'Save ( Editbox -> File )'   NAME mitSaveAs   ACTION  SaveAs()
            ITEM 'Replace ( Editbox -> MEMO )'  NAME mitReplace  ACTION  ReplMemo()
            ITEM 'Result'  NAME mitRsult   ACTION  SayResult()
            SEPARATOR
            ITEM "E&xit"  ACTION ThisWindow.Release
			END POPUP
      
		END MENU // MAIN
      
      @ 10,10 EDITBOX M_Resol1 ;       
              WIDTH 600 HEIGHT 400 ;
              VALUE "" ;
              FONT 'Courier New' SIZE 9 ;
              BACKCOLOR {250,250,210} ;
              TOOLTIP 'Edit here your text.' ;
              MAXLENGTH 0 ;
              NOHSCROLL      
            
      DEFINE STATUSBAR FONT 'Verdana' SIZE 8
          STATUSITEM ""
          STATUSITEM ""
          DATE WIDTH 80
          CLOCK WIDTH 90
      END STATUSBAR
         	
   END WINDOW
   
	CENTER   WINDOW frmMLTest
	ACTIVATE WINDOW frmMLTest

RETURN // MemLmtTest.Main()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROCEDURE Initilize()

   DBCREATE( MemoFName, aHFStruct, "DBFFPT", .T., "Test" )

   ReadFile()
   
RETURN // Initilize()   
      
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC ReadFile()


   ReadFName := Getfile( { {'Text (.txt) Files','*.txt'} },;     // acFilter
                    'Readf File' ,;                      // Title  
                    GetStartUpFolder(),;                // cDefaultPath 
                    .F.,;                               // lMultiSelect 
                    .T. )                               // lNoChangeCurrDir
         
   nReadLen := FILESIZE( ReadFName )
   
*  MSG_SETTEXT( GetControlHandle( "M_Resol1", "frmMLTest" ), MEMOREAD( ReadFName ) )
 
   frmMLTest.M_Resol1.Value := MEMOREAD( ReadFName )
   
   nEBValLen := LEN( MSG_GETTEXT( GetControlHandle( "M_Resol1", "frmMLTest" ) ) )
 
*  nEBValLen := LEN( frmMLTest.M_Resol1.Value ) <--- Unrecoverable error 6005: Exception error:
   
   Msg( TTrim( nReadLen ) + " bytes read from file and assigned " + TTrim( nEBValLen ) + " bytes to EditBox.", "Read result" )
   
   frmMLTest.StatusBar.Item( 1 ) := ReadFName
   frmMLTest.StatusBar.Item( 2 ) := TTrim( nEBValLen )

RETU // ReadFile()
                    
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC SaveAs() 
   SaveFName := PUTFILE()
   HB_MEMOWRIT( SaveFName, MSG_GETTEXT( GetControlHandle( "M_Resol1", "frmMLTest" ) ) )
   nSaveLen := FILESIZE( SaveFName )
   Msg( TTrim( nSaveLen ) + " bytes saved to " + SaveFName + " file", "Save result" )
RETU // SaveAs()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC ReplMemo()

   DBAPPEND()
   
   REPL GF_NAME WITH ReadFName,;   
       GF_DATA WITH MSG_GETTEXT( GetControlHandle( "M_Resol1", "frmMLTest" ) )
       
   nReplLen := LEN( GF_DATA )
   
   Msg( TTrim( nReplLen ) + " bytes replaced to MEMO field of " + MemoFName + " MEMO file", "replace result" )
       
RETU // ReplMemo()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-
                    
PROC SayResult()

   Msg( TTrim( nReadLen ) + " bytes read from " + ReadFName + " file" + CRLF +;
       TTrim( nSaveLen ) + " bytes saved to " + SaveFName + " file" + CRLF +;
       TTrim( nReplLen ) + " bytes replaced to MEMO field of " + MemoFName + " MEMO file", "Results" )

RETU // SayResult()
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

/*
use:
cHugeText := MSG_GETTEXT (GetControlHandle("EditBox_1","Form_1"))
instead of
cHugeText := Form_1.EditBox_1.Value 

*/

#pragma BEGINDUMP

#define COMPILE_HMG_UNICODE

#include "HMG_UNICODE.h"

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"

HB_FUNC (MSG_GETTEXT)
{  UINT nLen = 0;
   TCHAR *cText = NULL;
   nLen = (UINT) SendMessage ((HWND) hb_parnl(1), WM_GETTEXTLENGTH, 0, 0);
   if (nLen > 0)
   {  cText = (TCHAR*) hb_xgrab ((nLen+1) * sizeof(TCHAR));
      if (cText)
      {   SendMessage ((HWND) hb_parnl(1), WM_GETTEXT, nLen+1, (LPARAM) cText);
          HMG_retc( cText );
          hb_xfree( cText );
      }
      else
         HMG_retc(_TEXT(""));
   }
   else
      HMG_retc(_TEXT(""));
}


#pragma ENDDUMP


